/* stftr3.f -- translated by f2c (version 19990503).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "libtinyf2c.h"

/* ----------------------------------------------------------------------- */
/*     3-D TRANSFORMATION */
/* ----------------------------------------------------------------------- */
/*     Copyright (C) 2000 GFD Dennou Club. All rights reserved. */
/* ----------------------------------------------------------------------- */
/* Subroutine */ int stftr3_0_(int n__, real *ux, real *uy, real *uz, real *
	vx, real *vy, real *vz, integer *itr, real *cxa, real *cya, real *cza,
	 real *vxoff, real *vyoff, real *vzoff, logical *lxrd, logical *lyrd, 
	logical *lzrd, logical *lxlg, logical *lylg, logical *lzlg)
{
    /* Builtin functions */
    double r_lg10(real *);

    /* Local variables */
    extern doublereal rfpi_(void);
    static integer itrz;
    extern /* Subroutine */ int ct2pc_(real *, real *, real *, real *), 
	    ct3sc_(real *, real *, real *, real *, real *, real *);
    static logical lmiss;
    static real rmiss;
    static logical lxlgz, lylgz, lzlgz, lxrdz, lyrdz, lzrdz;
    static real cp, cx, cy, cz, xx, yy, zz;
    extern /* Subroutine */ int gllget_(char *, logical *, ftnlen), glrget_(
	    char *, real *, ftnlen);
    static real vx0, vy0, vz0, xxx, yyy, zzz;

    switch(n__) {
	case 1: goto L_ststr3;
	case 2: goto L_stsrd3;
	case 3: goto L_stslg3;
	}

    if (lmiss && (*ux == rmiss || *uy == rmiss || *uz == rmiss)) {
	*vx = rmiss;
	*vy = rmiss;
	*vz = rmiss;
	return 0;
    }
    xx = *ux;
    yy = *uy;
    zz = *uz;
    if (itrz == 1) {
	if (lxlgz) {
	    xx = r_lg10(&xx);
	}
	if (lylgz) {
	    yy = r_lg10(&yy);
	}
	if (lzlgz) {
	    zz = r_lg10(&zz);
	}
	xxx = xx;
	yyy = yy;
	zzz = zz;
    } else if (itrz == 2) {
	if (lxlgz) {
	    xx = r_lg10(&xx);
	}
	if (lyrdz) {
	    yy *= cp;
	}
	if (lzlgz) {
	    zz = r_lg10(&zz);
	}
	zzz = zz;
	ct2pc_(&xx, &yy, &xxx, &yyy);
    } else if (itrz == 3) {
	if (lxlgz) {
	    xx = r_lg10(&xx);
	}
	if (lyrdz) {
	    yy *= cp;
	}
	if (lzrdz) {
	    zz *= cp;
	}
	ct3sc_(&xx, &yy, &zz, &xxx, &yyy, &zzz);
    }
    *vx = cx * xxx + vx0;
    *vy = cy * yyy + vy0;
    *vz = cz * zzz + vz0;
    return 0;
/* ----------------------------------------------------------------------- */

L_ststr3:
    itrz = *itr;
    cx = *cxa;
    cy = *cya;
    cz = *cza;
    vx0 = *vxoff;
    vy0 = *vyoff;
    vz0 = *vzoff;
    cp = rfpi_() / 180;
    gllget_("LMISS", &lmiss, (ftnlen)5);
    glrget_("RMISS", &rmiss, (ftnlen)5);
    return 0;
/* ----------------------------------------------------------------------- */

L_stsrd3:
    lxrdz = *lxrd;
    lyrdz = *lyrd;
    lzrdz = *lzrd;
    return 0;
/* ----------------------------------------------------------------------- */

L_stslg3:
    lxlgz = *lxlg;
    lylgz = *lylg;
    lzlgz = *lzlg;
    return 0;
} /* stftr3_ */

/* Subroutine */ int stftr3_(real *ux, real *uy, real *uz, real *vx, real *vy,
	 real *vz)
{
    return stftr3_0_(0, ux, uy, uz, vx, vy, vz, (integer *)0, (real *)0, (
	    real *)0, (real *)0, (real *)0, (real *)0, (real *)0, (logical *)
	    0, (logical *)0, (logical *)0, (logical *)0, (logical *)0, (
	    logical *)0);
    }

/* Subroutine */ int ststr3_(integer *itr, real *cxa, real *cya, real *cza, 
	real *vxoff, real *vyoff, real *vzoff)
{
    return stftr3_0_(1, (real *)0, (real *)0, (real *)0, (real *)0, (real *)0,
	     (real *)0, itr, cxa, cya, cza, vxoff, vyoff, vzoff, (logical *)0,
	     (logical *)0, (logical *)0, (logical *)0, (logical *)0, (logical 
	    *)0);
    }

/* Subroutine */ int stsrd3_(logical *lxrd, logical *lyrd, logical *lzrd)
{
    return stftr3_0_(2, (real *)0, (real *)0, (real *)0, (real *)0, (real *)0,
	     (real *)0, (integer *)0, (real *)0, (real *)0, (real *)0, (real *
	    )0, (real *)0, (real *)0, lxrd, lyrd, lzrd, (logical *)0, (
	    logical *)0, (logical *)0);
    }

/* Subroutine */ int stslg3_(logical *lxlg, logical *lylg, logical *lzlg)
{
    return stftr3_0_(3, (real *)0, (real *)0, (real *)0, (real *)0, (real *)0,
	     (real *)0, (integer *)0, (real *)0, (real *)0, (real *)0, (real *
	    )0, (real *)0, (real *)0, (logical *)0, (logical *)0, (logical *)
	    0, lxlg, lylg, lzlg);
    }

